/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu.decoder;

import static ru.ispras.microtesk.model.cpu.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.cpu.TempVars;
import ru.ispras.microtesk.model.cpu.op.J;
import ru.ispras.microtesk.model.IsaPrimitive;

/**
 * The {@code DecoderJ} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderJ extends DecoderItem {
  private static DecoderJ instance = null;

  public static DecoderJ get() {
    if (null == instance) {
      instance = new DecoderJ();
    }
    return instance;
  }

  private DecoderJ() {
    super(
        10,
        true,
        "0100000000",
        "1100000000"
        );
  }

  public DecoderResult decode(final BitVector img) {
    if (!isOpcMatch(img)) {
      return null;
    }
    final BitVector image = img.field(0, this.getMaxImageSize() - 1);

    resetPosition();

    IsaPrimitive target = null;

    if (!matchNextOpc(image, BitVector.valueOf("01", 2, 2))) {
      return null;
    }
    target = (IsaPrimitive) readNextPrimitive(image, DecoderJ_ADDR.get());
    if (null == target) {
      return null;
    }

    return newResult(new J(target));
  }
}
