/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.decoder;

import static ru.ispras.microtesk.model.minimips.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.minimips.TempVars;
import ru.ispras.microtesk.model.minimips.op.lwc0;
import ru.ispras.microtesk.model.minimips.mode.RCOP0;
import ru.ispras.microtesk.model.Immediate;
import ru.ispras.microtesk.model.minimips.mode.REG;

/**
 * The {@code DecoderLwc0} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderLwc0 extends DecoderItem {
  private static DecoderLwc0 instance = null;

  public static DecoderLwc0 get() {
    if (null == instance) {
      instance = new DecoderLwc0();
    }
    return instance;
  }

  private DecoderLwc0() {
    super(
        32,
        true,
        "11000000000000000000000000000000",
        "11111100000000000000000000000000"
        );
  }

  public DecoderResult decode(final BitVector img) {
    if (!isOpcMatch(img)) {
      return null;
    }
    final BitVector image = img.field(0, this.getMaxImageSize() - 1);

    resetPosition();

    RCOP0 cs = null;
    Immediate offset = null;
    REG address = null;

    if (!matchNextOpc(image, BitVector.valueOf("110000", 2, 6))) {
      return null;
    }
    address = (REG) readNextPrimitive(image, DecoderREG.get());
    if (null == address) {
      return null;
    }
    cs = (RCOP0) readNextPrimitive(image, DecoderRCOP0.get());
    if (null == cs) {
      return null;
    }
    offset = readNextImmediate(image, SHORT);

    return newResult(new lwc0(cs, offset, address));
  }
}
