/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.decoder;

import static ru.ispras.microtesk.model.minimips.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.minimips.TempVars;
import ru.ispras.microtesk.model.minimips.op.sll;
import ru.ispras.microtesk.model.minimips.mode.REG;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderSll} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderSll extends DecoderItem {
  private static DecoderSll instance = null;

  public static DecoderSll get() {
    if (null == instance) {
      instance = new DecoderSll();
    }
    return instance;
  }

  private DecoderSll() {
    super(
        32,
        true,
        "00000000000000000000000000000000",
        "11111111111000000000000000111111"
        );
  }

  public DecoderResult decode(final BitVector img) {
    if (!isOpcMatch(img)) {
      return null;
    }
    final BitVector image = img.field(0, this.getMaxImageSize() - 1);

    resetPosition();

    REG rd = null;
    REG rt = null;
    Immediate sa = null;

    if (!matchNextOpc(image, BitVector.valueOf("00000000000", 2, 11))) {
      return null;
    }
    rt = (REG) readNextPrimitive(image, DecoderREG.get());
    if (null == rt) {
      return null;
    }
    rd = (REG) readNextPrimitive(image, DecoderREG.get());
    if (null == rd) {
      return null;
    }
    sa = readNextImmediate(image, Type.CARD(5));
    if (!matchNextOpc(image, BitVector.valueOf("000000", 2, 6))) {
      return null;
    }

    return newResult(new sll(rd, rt, sa));
  }
}
