/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.mmu.sim;

import java.util.Arrays;
import java.util.List;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.mmu.model.sim.*;
import ru.ispras.fortress.data.types.bitvector.*;

/**
 * The {@code L2} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class L2 extends CacheUnit<L2.Entry, PA> {
  private static List<L2> instancePool;

  public static L2 get(int id) {
    return getAll().get(id);
  }

  public static List<L2> getAll() {
    if (null == instancePool) {
      final L2 buffer0 = new L2(null);
      instancePool = Arrays.asList(buffer0);
    }
    return instancePool;
  }

  public static final class Entry extends StructBase<Entry> implements Struct<Entry> {
    public final BitVector V = BitVector.valueOf(0x0, 1);
    public final BitVector TAG = BitVector.newEmpty(15);
    public final BitVector DATA = BitVector.newEmpty(256);

    public Entry() {
      setEntry(
        BitVector.newMapping(
          V,
          TAG,
          DATA
        )
      );
    }

    public Entry(final BitVector value) {
      this();
      assign(value);
    }

    public void assign(final Entry other) {
      this.V.assign(other.V);
      this.TAG.assign(other.TAG);
      this.DATA.assign(other.DATA);
    }

    @Override
    public Entry newStruct(final BitVector value) {
      return new Entry(value);
    }

    @Override
    public String toString() {
      return String.format(
        "Entry [V=0x%s, TAG=0x%s, DATA=0x%s]",
        V.toHexString(),
        TAG.toHexString(),
        DATA.toHexString()
      );
    }
  }

  private static final Indexer<PA> INDEXER = new Indexer<PA>() {
    @Override
    public BitVector getIndex(final PA pa) {
      return pa.value.field(16, 5);
    }
  };

  private static final Matcher<L2.Entry, PA> MATCHER = new Matcher<L2.Entry, PA>() {
    @Override
    public boolean areMatching(final L2.Entry data, final PA pa) {
      return data.V.equals(BitVector.valueOf(0x1, 1)) && data.TAG.equals(pa.value.field(31, 17));
    }

    @Override
    public L2.Entry assignTag(final L2.Entry data, final PA pa) {
      data.V.assign(BitVector.valueOf(0x1, 1));
      data.TAG.assign(pa.value.field(31, 17));
      return data;
    }
  };

  private L2(Buffer<? extends Struct<?>, PA> next) {
    super(
      new L2.Entry(),
      new PA(),
      new BigInteger("4096", 10),
      4,
      CachePolicy.create(EvictionPolicyId.PLRU, WritePolicyId.WN, InclusionPolicyId.NINE, CoherenceProtocolId.NONE),
      INDEXER,
      MATCHER,
      next);
  }
}
