/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.mmu.sim;

import java.util.Arrays;
import java.util.List;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.mmu.model.sim.*;
import ru.ispras.fortress.data.types.bitvector.*;

/**
 * The {@code MMU_PA} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class MMU_PA extends RegisterMapping<MMU_PA.Entry, PA> {
  private static List<MMU_PA> instancePool;

  public static MMU_PA get(int id) {
    return getAll().get(id);
  }

  public static List<MMU_PA> getAll() {
    if (null == instancePool) {
      final MMU_PA buffer0 = new MMU_PA(null);
      instancePool = Arrays.asList(buffer0);
    }
    return instancePool;
  }

  public static final class Entry extends StructBase<Entry> implements Struct<Entry> {
    public final BitVector value = BitVector.newEmpty(32);

    public Entry() {
      setEntry(
        BitVector.newMapping(
          value
        )
      );
    }

    public Entry(final BitVector value) {
      this();
      assign(value);
    }

    public void assign(final Entry other) {
      this.value.assign(other.value);
    }

    @Override
    public Entry newStruct(final BitVector value) {
      return new Entry(value);
    }

    @Override
    public String toString() {
      return String.format(
        "Entry [value=0x%s]",
        value.toHexString()
      );
    }
  }

  private static final Indexer<PA> INDEXER = new Indexer<PA>() {
    @Override
    public BitVector getIndex(final PA pa) {
      return BitVector.valueOf(0x0, 32);
    }
  };

  private static final Matcher<MMU_PA.Entry, PA> MATCHER = new Matcher<MMU_PA.Entry, PA>() {
    @Override
    public boolean areMatching(final MMU_PA.Entry data, final PA pa) {
      return true;
    }

    @Override
    public MMU_PA.Entry assignTag(final MMU_PA.Entry data, final PA pa) {
      return data;
    }
  };

  private MMU_PA(Buffer<? extends Struct<?>, PA> next) {
    super(
      new MMU_PA.Entry(),
      new PA(),
      "MMU_PA",
      new BigInteger("1", 10),
      1,
      CachePolicy.create(EvictionPolicyId.NONE, WritePolicyId.WN, InclusionPolicyId.NINE, CoherenceProtocolId.NONE),
      INDEXER,
      MATCHER);
  }
}
