/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.decoder;

import static ru.ispras.microtesk.model.vliw.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.vliw.TempVars;
import ru.ispras.microtesk.model.vliw.op.C_LE_S;
import ru.ispras.microtesk.model.vliw.mode.F;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderC_LE_S} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderC_LE_S extends DecoderItem {
  private static DecoderC_LE_S instance = null;

  public static DecoderC_LE_S get() {
    if (null == instance) {
      instance = new DecoderC_LE_S();
    }
    return instance;
  }

  private DecoderC_LE_S() {
    super(
        32,
        true,
        "01000110000000000000000000111110",
        "11111111111000000000000011111111"
        );
  }

  public DecoderResult decode(final BitVector img) {
    if (!isOpcMatch(img)) {
      return null;
    }
    final BitVector image = img.field(0, this.getMaxImageSize() - 1);

    resetPosition();

    F ft = null;
    F fs = null;
    Immediate cc = null;

    if (!matchNextOpc(image, BitVector.valueOf("01000110000", 2, 11))) {
      return null;
    }
    ft = (F) readNextPrimitive(image, DecoderF.get());
    if (null == ft) {
      return null;
    }
    fs = (F) readNextPrimitive(image, DecoderF.get());
    if (null == fs) {
      return null;
    }
    cc = readNextImmediate(image, COND_CODE);
    if (!matchNextOpc(image, BitVector.valueOf("00111110", 2, 8))) {
      return null;
    }

    return newResult(new C_LE_S(ft, fs, cc));
  }
}
