/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.decoder;

import static ru.ispras.microtesk.model.vliw.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.vliw.TempVars;
import ru.ispras.microtesk.model.vliw.op.SLL;
import ru.ispras.microtesk.model.vliw.mode.R;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderSLL} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderSLL extends DecoderItem {
  private static DecoderSLL instance = null;

  public static DecoderSLL get() {
    if (null == instance) {
      instance = new DecoderSLL();
    }
    return instance;
  }

  private DecoderSLL() {
    super(
        32,
        true,
        "00000000000000000000000000000000",
        "11111111111000000000000000111111"
        );
  }

  public DecoderResult decode(final BitVector img) {
    if (!isOpcMatch(img)) {
      return null;
    }
    final BitVector image = img.field(0, this.getMaxImageSize() - 1);

    resetPosition();

    R rd = null;
    R rt = null;
    Immediate sa = null;

    if (!matchNextOpc(image, BitVector.valueOf("00000000000", 2, 11))) {
      return null;
    }
    rt = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rt) {
      return null;
    }
    rd = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rd) {
      return null;
    }
    sa = readNextImmediate(image, INDEX);
    if (!matchNextOpc(image, BitVector.valueOf("000000", 2, 6))) {
      return null;
    }

    return newResult(new SLL(rd, rt, sa));
  }
}
