/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vmem.decoder;

import static ru.ispras.microtesk.model.vmem.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.vmem.TempVars;
import ru.ispras.microtesk.model.vmem.op.ld;
import ru.ispras.microtesk.model.vmem.mode.REG;

/**
 * The {@code DecoderLd} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderLd extends DecoderItem {
  private static DecoderLd instance = null;

  public static DecoderLd get() {
    if (null == instance) {
      instance = new DecoderLd();
    }
    return instance;
  }

  private DecoderLd() {
    super(
        16,
        true,
        "1001000000000000",
        "1111111100000000"
        );
  }

  public DecoderResult decode(final BitVector img) {
    if (!isOpcMatch(img)) {
      return null;
    }
    final BitVector image = img.field(0, this.getMaxImageSize() - 1);

    resetPosition();

    REG rt = null;
    REG addr = null;

    if (!matchNextOpc(image, BitVector.valueOf("10010000", 2, 8))) {
      return null;
    }
    rt = (REG) readNextPrimitive(image, DecoderREG.get());
    if (null == rt) {
      return null;
    }
    addr = (REG) readNextPrimitive(image, DecoderREG.get());
    if (null == addr) {
      return null;
    }

    return newResult(new ld(rt, addr));
  }
}
