/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vmem.mmu.sim;

import java.util.Arrays;
import java.util.List;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.mmu.model.sim.*;
import ru.ispras.fortress.data.types.bitvector.*;

/**
 * The {@code L2} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class L2 extends CacheUnit<L2.Entry, PA> {
  private static List<L2> instancePool;

  public static L2 get(int id) {
    return getAll().get(id);
  }

  public static List<L2> getAll() {
    if (null == instancePool) {
      final L2 buffer0 = new L2(MEM.get(0));
      instancePool = Arrays.asList(buffer0);
    }
    return instancePool;
  }

  public static final class Entry extends StructBase<Entry> implements Struct<Entry> {
    public final BitVector tag = BitVector.newEmpty(8);
    public final BitVector data = BitVector.newEmpty(16);

    public Entry() {
      setEntry(
        BitVector.newMapping(
          tag,
          data
        )
      );
    }

    public Entry(final BitVector value) {
      this();
      assign(value);
    }

    public void assign(final Entry other) {
      this.tag.assign(other.tag);
      this.data.assign(other.data);
    }

    @Override
    public Entry newStruct(final BitVector value) {
      return new Entry(value);
    }

    @Override
    public String toString() {
      return String.format(
        "Entry [tag=0x%s, data=0x%s]",
        tag.toHexString(),
        data.toHexString()
      );
    }
  }

  private static final Indexer<PA> INDEXER = new Indexer<PA>() {
    @Override
    public BitVector getIndex(final PA pa) {
      return pa.value.field(5, 1);
    }
  };

  private static final Matcher<L2.Entry, PA> MATCHER = new Matcher<L2.Entry, PA>() {
    @Override
    public boolean areMatching(final L2.Entry data, final PA pa) {
      return pa.value.field(13, 6).equals(data.tag);
    }

    @Override
    public L2.Entry assignTag(final L2.Entry data, final PA pa) {
      data.tag.assign(pa.value.field(13, 6));
      return data;
    }
  };

  private L2(Buffer<? extends Struct<?>, PA> next) {
    super(
      new L2.Entry(),
      new PA(),
      new BigInteger("32", 10),
      1,
      CachePolicy.create(EvictionPolicyId.FIFO, WritePolicyId.WN, InclusionPolicyId.NINE, CoherenceProtocolId.NONE),
      INDEXER,
      MATCHER,
      next);
  }
}
