/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vmem.mmu.sim;

import java.util.Arrays;
import java.util.List;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.mmu.model.sim.*;
import ru.ispras.fortress.data.types.bitvector.*;

/**
 * The {@code MEM} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class MEM extends Memory<MEM.Entry, PA> {
  private static List<MEM> instancePool;

  public static MEM get(int id) {
    return getAll().get(id);
  }

  public static List<MEM> getAll() {
    if (null == instancePool) {
      final MEM buffer0 = new MEM();
      instancePool = Arrays.asList(buffer0);
    }
    return instancePool;
  }

  public static final class Entry extends StructBase<Entry> implements Struct<Entry> {
    public final BitVector data = BitVector.newEmpty(16);

    public Entry() {
      setEntry(
        BitVector.newMapping(
          data
        )
      );
    }

    public Entry(final BitVector value) {
      this();
      assign(value);
    }

    public void assign(final Entry other) {
      this.data.assign(other.data);
    }

    @Override
    public Entry newStruct(final BitVector value) {
      return new Entry(value);
    }

    @Override
    public String toString() {
      return String.format(
        "Entry [data=0x%s]",
        data.toHexString()
      );
    }
  }
  private MEM() {
    super(
      new MEM.Entry(),
      new PA(),
      new BigInteger("4000", 16)
    );
  }
}
