/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vmem.mmu.sim;

import java.util.Arrays;
import java.util.List;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.mmu.model.sim.*;
import ru.ispras.fortress.data.types.bitvector.*;

/**
 * The {@code PageTable} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class PageTable extends MmuMapping<PageTable.Entry, VA> {
  private static List<PageTable> instancePool;

  public static PageTable get(int id) {
    return getAll().get(id);
  }

  public static List<PageTable> getAll() {
    if (null == instancePool) {
      final PageTable buffer0 = new PageTable(null);
      instancePool = Arrays.asList(buffer0);
    }
    return instancePool;
  }

  public static final class Entry extends StructBase<Entry> implements Struct<Entry> {
    public final BitVector vpn = BitVector.newEmpty(6);
    public final BitVector pfn = BitVector.newEmpty(6);
    public final BitVector unused = BitVector.newEmpty(4);

    public Entry() {
      setEntry(
        BitVector.newMapping(
          vpn,
          pfn,
          unused
        )
      );
    }

    public Entry(final BitVector value) {
      this();
      assign(value);
    }

    public void assign(final Entry other) {
      this.vpn.assign(other.vpn);
      this.pfn.assign(other.pfn);
      this.unused.assign(other.unused);
    }

    @Override
    public Entry newStruct(final BitVector value) {
      return new Entry(value);
    }

    @Override
    public String toString() {
      return String.format(
        "Entry [vpn=0x%s, pfn=0x%s, unused=0x%s]",
        vpn.toHexString(),
        pfn.toHexString(),
        unused.toHexString()
      );
    }
  }

  private static final Indexer<VA> INDEXER = new Indexer<VA>() {
    @Override
    public BitVector getIndex(final VA va) {
      return va.value.field(13, 8);
    }
  };

  private static final Matcher<PageTable.Entry, VA> MATCHER = new Matcher<PageTable.Entry, VA>() {
    @Override
    public boolean areMatching(final PageTable.Entry data, final VA va) {
      return va.value.field(13, 8).equals(data.vpn);
    }

    @Override
    public PageTable.Entry assignTag(final PageTable.Entry data, final VA va) {
      data.vpn.assign(va.value.field(13, 8));
      return data;
    }
  };

  private PageTable(Buffer<? extends Struct<?>, VA> next) {
    super(
      new PageTable.Entry(),
      new VA(),
      new BigInteger("64", 10),
      1,
      CachePolicy.create(EvictionPolicyId.NONE, WritePolicyId.WN, InclusionPolicyId.NINE, CoherenceProtocolId.NONE),
      INDEXER,
      MATCHER);
  }

  @Override
  protected Mmu<VA> getMmu() {
    return vmem.get();
  }
}
