/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vmem.mmu.sim;

import java.util.Arrays;
import java.util.List;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.mmu.model.sim.*;
import ru.ispras.fortress.data.types.bitvector.*;

/**
 * The {@code TLB} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class TLB extends CacheUnit<TLB.Entry, VA> {
  private static List<TLB> instancePool;

  public static TLB get(int id) {
    return getAll().get(id);
  }

  public static List<TLB> getAll() {
    if (null == instancePool) {
      final TLB buffer0 = new TLB(null);
      instancePool = Arrays.asList(buffer0);
    }
    return instancePool;
  }

  public static final class Entry extends StructBase<Entry> implements Struct<Entry> {
    public final BitVector vpn = BitVector.newEmpty(6);
    public final BitVector pfn = BitVector.newEmpty(6);

    public Entry() {
      setEntry(
        BitVector.newMapping(
          vpn,
          pfn
        )
      );
    }

    public Entry(final BitVector value) {
      this();
      assign(value);
    }

    public void assign(final Entry other) {
      this.vpn.assign(other.vpn);
      this.pfn.assign(other.pfn);
    }

    @Override
    public Entry newStruct(final BitVector value) {
      return new Entry(value);
    }

    @Override
    public String toString() {
      return String.format(
        "Entry [vpn=0x%s, pfn=0x%s]",
        vpn.toHexString(),
        pfn.toHexString()
      );
    }
  }

  private static final Indexer<VA> INDEXER = new Indexer<VA>() {
    @Override
    public BitVector getIndex(final VA va) {
      return BitVector.valueOf(0x0, 16);
    }
  };

  private static final Matcher<TLB.Entry, VA> MATCHER = new Matcher<TLB.Entry, VA>() {
    @Override
    public boolean areMatching(final TLB.Entry data, final VA va) {
      return va.value.field(13, 8).equals(data.vpn);
    }

    @Override
    public TLB.Entry assignTag(final TLB.Entry data, final VA va) {
      data.vpn.assign(va.value.field(13, 8));
      return data;
    }
  };

  private TLB(Buffer<? extends Struct<?>, VA> next) {
    super(
      new TLB.Entry(),
      new VA(),
      new BigInteger("1", 10),
      4,
      CachePolicy.create(EvictionPolicyId.FIFO, WritePolicyId.WN, InclusionPolicyId.NINE, CoherenceProtocolId.NONE),
      INDEXER,
      MATCHER,
      next);
  }
}
