/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86gnu.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.x86gnu.mode.*;
import ru.ispras.microtesk.model.x86gnu.PE;
import ru.ispras.microtesk.model.x86gnu.TempVars;

import static ru.ispras.microtesk.model.x86gnu.TypeDefs.*;
import static ru.ispras.microtesk.translator.nml.ir.primitive.Primitive.Modifier.*;

public final class or_r16m16 extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "or_r16m16",
          or_r16m16.class,
          null
          );
      addArgument("seg_ovrd", RSEG16.INFO);
      addArgument("op1", R16.INFO);
      addArgument("op2", MOFFS.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final R16 op1 = (R16) getArgument("op1", args);
      final IsaPrimitive op2 = (IsaPrimitive) getArgument("op2", args);

      return new or_r16m16(seg_ovrd, op1, op2);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "or_r16m16",
          instruction.class,
          null
          );
      addArgument("seg_ovrd", RSEG16.INFO);
      addArgument("op1", R16.INFO);
      addArgument("op2", MOFFS.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final R16 op1 = (R16) getArgument("op1", args);
      final IsaPrimitive op2 = (IsaPrimitive) getArgument("op2", args);

      return new instruction(
        new or_r16m16(
          seg_ovrd,
          op1,
          op2
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final RSEG16 seg_ovrd;
  public final R16 op1;
  public final IsaPrimitive op2;

  public or_r16m16(final RSEG16 seg_ovrd, final R16 op1, final IsaPrimitive op2) {
    this.modifier = NORMAL;
    this.seg_ovrd = seg_ovrd;
    this.op1 = op1;
    this.op2 = op2;

    addArgument("seg_ovrd", seg_ovrd);
    addArgument("op1", op1);
    addArgument("op2", op2);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.mod.access().store(Data.valueOf(Type.CARD(2), 0x0));
    vars__.rm.access().store(Data.valueOf(Type.CARD(3), 0x0));
    op2.init(vars__);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("or %s, %s:%s", op1.text(vars__), seg_ovrd.text(vars__), op2.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("001%s11000001011%s%s%s%s", seg_ovrd.image(vars__), vars__.mod.access().load().toString(), op1.image(vars__), vars__.rm.access().load().toString(), op2.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    vars__.base.access().store(Data.zeroExtend(addR, seg_ovrd.access(pe__, vars__).load()).shiftLeft(Data.valueOf(addR, 0x4)));
    new or_proc_word(new Immediate(Location.concat(pe__.MEM.access(vars__.base.access().load().add(op2.access(pe__, vars__).load()).add(Data.valueOf(addR, 0x1))), pe__.MEM.access(vars__.base.access().load().add(op2.access(pe__, vars__).load())))), new Immediate(op1.access(pe__, vars__).load().add(Data.valueOf(WORD, 0x0)))).execute(pe__, vars__);
    pe__.MEM.access(vars__.base.access().load().add(op2.access(pe__, vars__).load())).store(vars__.tmpw_res.access().bitField(7, 0).load());
    pe__.MEM.access(vars__.base.access().load().add(op2.access(pe__, vars__).load()).add(Data.valueOf(addR, 0x1))).store(vars__.tmpw_res.access().bitField(15, 8).load());
    op2.execute(pe__, vars__);
    vars__.instruction_image_size.access().store(Data.valueOf(SIZE, 0x3));
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}