/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86nasm.decoder;

import static ru.ispras.microtesk.model.x86nasm.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.x86nasm.TempVars;
import ru.ispras.microtesk.model.x86nasm.op.jmp_long;
import ru.ispras.microtesk.model.IsaPrimitive;

/**
 * The {@code DecoderJmp_long} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderJmp_long extends DecoderItem {
  private static DecoderJmp_long instance = null;

  public static DecoderJmp_long get() {
    if (null == instance) {
      instance = new DecoderJmp_long();
    }
    return instance;
  }

  private DecoderJmp_long() {
    super(
        24,
        true,
        "111010010000000000000000",
        "111111110000000000000000"
        );
  }

  public DecoderResult decode(final BitVector img) {
    if (!isOpcMatch(img)) {
      return null;
    }
    final BitVector image = img.field(0, this.getMaxImageSize() - 1);

    resetPosition();

    IsaPrimitive rel = null;

    if (!matchNextOpc(image, BitVector.valueOf("11101001", 2, 8))) {
      return null;
    }
    rel = (IsaPrimitive) readNextPrimitive(image, DecoderREL16.get());
    if (null == rel) {
      return null;
    }

    return newResult(new jmp_long(rel));
  }
}
