/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86nasm.decoder;

import static ru.ispras.microtesk.model.x86nasm.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.x86nasm.TempVars;
import ru.ispras.microtesk.model.x86nasm.op.mov_r8i8;
import ru.ispras.microtesk.model.x86nasm.mode.R8;
import ru.ispras.microtesk.model.x86nasm.mode.IMM8;

/**
 * The {@code DecoderMov_r8i8} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderMov_r8i8 extends DecoderItem {
  private static DecoderMov_r8i8 instance = null;

  public static DecoderMov_r8i8 get() {
    if (null == instance) {
      instance = new DecoderMov_r8i8();
    }
    return instance;
  }

  private DecoderMov_r8i8() {
    super(
        24,
        true,
        "101100001100100000000000",
        "111110001111100000000000"
        );
  }

  public DecoderResult decode(final BitVector img) {
    if (!isOpcMatch(img)) {
      return null;
    }
    final BitVector image = img.field(0, this.getMaxImageSize() - 1);

    resetPosition();

    R8 dst = null;
    IMM8 src = null;

    if (!matchNextOpc(image, BitVector.valueOf("10110", 2, 5))) {
      return null;
    }
    dst = (R8) readNextPrimitive(image, DecoderR8.get());
    if (null == dst) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("11001", 2, 5))) {
      return null;
    }
    dst = (R8) readNextPrimitive(image, DecoderR8.get());
    if (null == dst) {
      return null;
    }
    src = (IMM8) readNextPrimitive(image, DecoderIMM8.get());
    if (null == src) {
      return null;
    }

    return newResult(new mov_r8i8(dst, src));
  }
}
