/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86nasm.decoder;

import static ru.ispras.microtesk.model.x86nasm.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.x86nasm.TempVars;
import ru.ispras.microtesk.model.x86nasm.op.push_rseg;
import ru.ispras.microtesk.model.x86nasm.mode.RSEG16;

/**
 * The {@code DecoderPush_rseg} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderPush_rseg extends DecoderItem {
  private static DecoderPush_rseg instance = null;

  public static DecoderPush_rseg get() {
    if (null == instance) {
      instance = new DecoderPush_rseg();
    }
    return instance;
  }

  private DecoderPush_rseg() {
    super(
        9,
        false,
        null,
        null
        );
  }

  public DecoderResult decode(final BitVector img) {
    if (!isOpcMatch(img)) {
      return null;
    }
    final BitVector image = img.field(0, this.getMaxImageSize() - 1);

    resetPosition();

    RSEG16 src = null;

    if (!matchNextOpc(image, BitVector.valueOf("000", 2, 3))) {
      return null;
    }
    src = (RSEG16) readNextPrimitive(image, DecoderRSEG16.get());
    if (null == src) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("110", 2, 3))) {
      return null;
    }

    return newResult(new push_rseg(src));
  }
}
