/*
 * Copyright 2012-2020 ISP RAS (http://www.ispras.ru)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

lexer grammar MmuLexer;

import commonLexer=CommonLexer;

//==================================================================================================
// Header for the generated Java class file.
//==================================================================================================

@header {
/*
 * Copyright 2012-2020 ISP RAS (http://www.ispras.ru)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 *
 * WARNING: THIS FILE IS AUTOMATICALLY GENERATED. PLEASE DO NOT MODIFY IT. 
 */

package ru.ispras.microtesk.mmu.translator.grammar;

import ru.ispras.microtesk.translator.antlrex.Preprocessor;
import ru.ispras.microtesk.translator.antlrex.symbols.SymbolTable;
}

@members {
  private Preprocessor pp = null;

  public MmuLexer(final CharStream chars, final Preprocessor pp, final SymbolTable symbols) {
    this(chars);

    commonLexer.setPreprocessor(pp);
    this.pp = pp;

    commonLexer.setSymbols(symbols);
  }

  private void pp() {
    if(pp.isHidden()) {
      skip();
    }
  }
}

//==================================================================================================
// MMU Keywords
//==================================================================================================

MMU_LET     : 'let'     { pp(); };
MMU_EXTERN  : 'extern'  { pp(); };

MMU_STRUCT  : 'struct'  { pp(); };
MMU_ADDRESS : 'address' { pp(); };

MMU_SEGMENT : 'segment' { pp(); };
MMU_RANGE   : 'range'   { pp(); };

MMU_BUFFER  : 'buffer'  { pp(); };
MMU_VIEWOF  : 'viewof'  { pp(); };
MMU_WAYS    : 'ways'    { pp(); };
MMU_SETS    : 'sets'    { pp(); };
MMU_ENTRY   : 'entry'   { pp(); };
MMU_INDEX   : 'index'   { pp(); };
MMU_MATCH   : 'match'   { pp(); };
MMU_POLICY  : 'policy'  { pp(); };
MMU_NEXT    : 'next'    { pp(); };

MMU         : 'mmu'     { pp(); };
MMU_VAR     : 'var'     { pp(); };

MMU_OP      : 'op'      { pp(); };

//==================================================================================================
// The End
//==================================================================================================
