/*
 * Copyright 2022 ISP RAS (http://www.ispras.ru)
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package ru.ispras.microtesk.tools.adapter.trace;

/**
 * @author <a href="mailto:protsenko@ispras.ru">Alexander Protsenko</a>
 */
public class EventElementPattern {
  private final EventElementType type;
  private final String regEx;

  public EventElementPattern (final EventElementType type, final String regEx) {
    this.type = type;
    this.regEx = regEx;
  }

  /**
   * @return the type of event element
   */
  public EventElementType getType() {
    return type;
  }

  /**
   * @return the event element regular expressions
   */
  public String getRegEx() {
    return regEx;
  }

  @Override
  public String toString() {
    return String.format("[%s]: type - \"%s\", regEx - \"%s\"",this.getClass().getSimpleName(), type.getName(), regEx);
  }
}