/*
 * Copyright 2021 ISP RAS (http://www.ispras.ru)
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package ru.ispras.microtesk.tools.simulator;

import java.util.List;

import ru.ispras.castle.util.Logger;
import ru.ispras.microtesk.model.IsaPrimitive;
import ru.ispras.microtesk.model.Model;
import ru.ispras.microtesk.options.Options;

/**
 * @author <a href="mailto:protsenko@ispras.ru">Alexander Protsenko</a>
 */
public class BinProgramReader extends BinaryProgramReader {
  public static final String FILE_EXTENSION = ".bin";

  BinProgramReader(final Model model, final Options options, final String fileName) {
    super(model, options, fileName);

    Logger.debug("Constructor for class: %s. [Input] fileName: %s", this.getClass().getSimpleName(), fileName);
  }

  @Override
  public IrProgram getProgram() {
    // Disassemble instructions
    final List<IsaPrimitive> program = disassembleProgram();

    return new IrProgram(program, this.programFileNameNoExt);
  }
}
