package ru.ispras.microtesk.tools.simulator.memory;

import ru.ispras.fortress.data.types.bitvector.BitVector;

public class Element {
  final int address;
  final BitVector value;

  final String memoryName;
  final String memoryType;
  final String type;

  public Element(final int address, final BitVector value, final String memoryName,
      final String memoryType, final String type) {
    this.address = address;
    this.value = value;
    this.memoryName = memoryName;
    this.memoryType = memoryType;
    this.type = type;
  }

  public Element(final int address, final int value, final String memoryName,
      final String memoryType, final String type) {
    // TODO: bitSize(not 16)
    this(address, BitVector.valueOf(value, 16), memoryName, memoryType, type);
  }

  @Override
  public String toString() {
    return String.format("Mem [%s] type (%s), address: %s, value: 0x%s (%s)", memoryName,
        memoryType, Integer.toHexString(address), value.toHexString(), type);
  }

  public int getAddress() {
    return address;
  }

  public BitVector getValue() {
    return value;
  }

  public String getMemoryName() {
    return memoryName;
  }
}
