/*
 * Copyright 2023 ISP RAS (http://www.ispras.ru)
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package ru.ispras.microtesk.tools.simulator.memory;

import java.nio.file.Path;

/**
 * @author <a href="mailto:protsenko@ispras.ru">Alexander Protsenko</a>
 */
public class MemoryFiles {
  private final Path memoryPathsFile;
  private final Path sourceDirectory;

  public MemoryFiles(final Path memoryPathsFile, final Path sourceDirectory) {
    this.memoryPathsFile = memoryPathsFile;
    this.sourceDirectory = sourceDirectory;
  }

  public Path getMemoryPathsFile() {
    return memoryPathsFile;
  }

  public Path getSourceDirectory() {
    return sourceDirectory;
  }
}
