/*
 * Copyright 2021 ISP RAS (http://www.ispras.ru)
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package ru.ispras.microtesk.tools.templgen.printers;

/**
 * @author <a href="mailto:protsenko@ispras.ru">Alexander Protsenko</a>
 */
public interface ElementPrinter {

  /**
   * Adds a {@code EventPrinter} to element.
   *
   * @param element element for print.
   */
  public abstract void addElement(final ElementPrinter element);

  /**
   * Returns a nesting level of element.
   *
   * @return level in the hierarchy of elements.
   */
  public abstract int getLevel();

  /**
   * Prints the element.
   */
  public abstract void printElement();
}
