/*
 * Copyright 2022 ISP RAS (http://www.ispras.ru)
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package ru.ispras.microtesk.model.memory.loader;

import org.junit.Assert;
import org.junit.Test;

public class MemoryRegionTestCase {
  @Test
  public void createMemoryRegion() {
    final String memoryName = "MEM_TEMP";
    final int start = 0x100;
    final int end = 0x200;
    final String type = "class";

    MemoryRegion memoryRegion = new MemoryRegion(memoryName, start, end, type);
    Assert.assertEquals(memoryRegion.getMemoryName(), memoryName);
    Assert.assertEquals(memoryRegion.getStartIndex(), start);
    Assert.assertEquals(memoryRegion.getEndIndex(), end);
    Assert.assertEquals(memoryRegion.getType(), type);
    System.out.println(memoryRegion);
  }
}
