/*
 * Copyright 2022 ISP RAS (http://www.ispras.ru)
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package ru.ispras.microtesk.tools.adapter.trace;

import static org.junit.Assert.assertEquals;

import java.util.HashMap;
import java.util.Map;

import org.junit.Test;

import ru.ispras.castle.util.Logger;

/**
 * @author <a href="mailto:protsenko@ispras.ru">Alexander Protsenko</a>
 */
public class ConcreteEventTestCase {
  @Test
  public void simpleConcreteEventCheck() {
    final Map<EventElementType, String> eventElements = new HashMap<>();
    eventElements.put(EventElementType.THREAD_IDENTIFIER, "002b0a");
    eventElements.put(EventElementType.REGISTER, "v1");
    eventElements.put(EventElementType.REGISTER_VALUE, "7");

    ConcreteEvent concreteEvent = new ConcreteEvent(EventType.MEMORY, eventElements);
    Logger.debug("%s", concreteEvent);

    assertEquals(EventType.MEMORY, concreteEvent.getEventType());
    assertEquals("002b0a", concreteEvent.getElement(EventElementType.THREAD_IDENTIFIER));
    assertEquals("v1", concreteEvent.getElement(EventElementType.REGISTER));
    assertEquals("7", concreteEvent.getElement(EventElementType.REGISTER_VALUE));
  }
}
