/*
 * Copyright 2022 ISP RAS (http://www.ispras.ru)
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package ru.ispras.microtesk.tools.adapter.trace;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotEquals;

import org.junit.Test;

/**
 * @author <a href="mailto:protsenko@ispras.ru">Alexander Protsenko</a>
 */
public class EventElementTypeTestCase {
  @Test
  public void testElementName() {
    assertEquals(EventElementType.REGISTER.name().toLowerCase(),
        EventElementType.REGISTER.getName().toLowerCase());
  }

  @Test
  public void testElementNotEnumName() {
    assertNotEquals(EventElementType.REGISTER.name(), EventElementType.REGISTER.getName());
  }

  @Test
  public void testGetEventElementType() {
    assertEquals(EventElementType.REGISTER, EventElementType.getType("Register"));
  }

  @Test(expected = IllegalArgumentException.class)
  public void testGetEnumException() {
    EventElementType.valueOf(EventElementType.THREAD_IDENTIFIER.getName().toUpperCase());
  }
}
